require "narray"
require "numru/dcl"
require "numru/gdcl"

include NumRu

class NData

  def initialize(hash)
    @size = hash["ƥå׿"].get_text.to_i + 1
    @x = NArray.float(@size)
    @y = NArray.float(@size)
    @x[0] = 0.0
    @y[0] = hash[""].get_text.to_f

    @draw_area = Gtk::DrawingArea.new
    @draw_area.size(600, 600)
    @draw_area.signal_connect("configure_event"){|w,e| configure_event(w,e)}
    @draw_area.signal_connect("expose_event"){|w,e| expose_event(w,e)}
    @draw_area.signal_connect("button_press_event"){ close }
    @draw_area.add_events(Gdk::BUTTON_PRESS_MASK)
    @draw_area.show

    @window = Gtk::Window.new(Gtk::WINDOW_TOPLEVEL)
    @window.signal_connect("delete_event"){exit}
    @window.signal_connect("destroy_event"){exit}
    @window.realize
    @window.set_title("demo")
    @window.add(@draw_area)
    @window.show
  end

  def configure_event(widget, e)
    @w = widget
    geom = widget.window.get_geometry
    if ! @pixmap.nil? then
      @pixmap = nil
    end
    if (geom[2]>0 && geom[3]>0) then
      @pixmap = Gdk::Pixmap.new(widget.window, geom[2], geom[3], -1)
      @pixmap.draw_rectangle(@draw_area.style.white_gc, true, 0, 0, 
			     geom[2], geom[3])
    end

    GDCL::zgsdrw(widget)
    DCL::sgopn(4)
    draw_graph
  end

  def expose_event(widget, e)
    if ! @pixmap.nil?
      area = e.area
      gc = @draw_area.style.fg_gc(widget.state)
      widget.window.draw_pixmap(gc, @pixmap, area.x, area.y,
                             area.x, area.y, area.width, area.height)
    end
  end

  def update(obj, i)
    @i = i + 1
    @x[i] = i.to_f
    @y[i] = obj.get
    draw_graph
  end

  def draw_graph

    GDCL::zgspmp(@pixmap)

    DCL::grfrm
    DCL::grswnd(0.0, @size.to_f, -1.0, 1.0)
    DCL::grsvpt(0.2, 0.8, 0.2, 0.8)
    DCL::ussttl('X-TITLE', 'x-unit', 'Y-TITLE', 'y-unit')
    DCL::usgrph(@i, @x,  @y) if !@i.nil?

    geom = @w.window.get_geometry
    gc = @draw_area.style.fg_gc(@w.state)
    @w.window.draw_pixmap(gc, @pixmap, 0, 0, 0, 0, geom[2], geom[3])

  end

  def run

  end

  def close
    @window.destroy
  end

end
