require 'gtk'
require 'observer'
class Menu

  include Observable

  HEIGHT = 20
  LABEL_WIDTH = 100
  ENTRY_WIDTH = 200

  def set(hash)
    @hash = hash
  end

  def run
    table = Gtk::Table.new(3, @hash.length, false)

    @entry_hash = Hash.new

    i = 0
    @hash.each_key{|key|
      @entry_hash[key] = Gtk::Entry.new
      @entry_hash[key].set_text(@hash[key].to_s)
      @entry_hash[key].set_usize(ENTRY_WIDTH, HEIGHT)

      label = Gtk::Label.new(key)
      label.set_usize(LABEL_WIDTH, HEIGHT)

      table.attach(label, 0, 1, i, i+1)
      table.attach(@entry_hash[key], 1, 2, i, i+1)

      i+=1
    }

    button = Gtk::Button.new("¹")
    button.signal_connect("clicked") {button_clicked}
    table.attach(button, 1,2,i,i+1)

    i+=1

    button = Gtk::Button.new("λ")
    button.signal_connect("clicked") {exit}
    table.attach(button, 1,2,i,i+1)

    window = Gtk::Window.new(Gtk::WINDOW_TOPLEVEL)
    window.signal_connect("delete_event"){exit}
    window.add(table)
    window.show_all


    Gtk.main

  end

  def button_clicked
    changed
    notify_observers(@entry_hash)
  end

  def get(key)
    @entry_hash[key].get_text
  end

end
